﻿Option Strict On
Imports System.IO
Imports Ionic.Zip
Imports System.Threading
Imports Chilkat

Public Class Form1

    'FTP-Funktion laden


    Public Sub New()

        ' Dieser Aufruf ist für den Windows Form-Designer erforderlich.
        InitializeComponent()

        'Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.


    End Sub
    '#################Definieren der FTP Daten###########################################
    Dim getting As String
    Dim gettinglocal As String = Application.StartupPath & "\get.dll"

    Dim ftp As New Chilkat.Ftp2()
    Dim success As Boolean

    Dim sFile As String = Application.StartupPath & "\log.dat"

    Private Weiter As Boolean = False
    Private ms As Integer
    'Wartezeit in ms umgerechnet und der Thread gestartet
    Public Sub Wartezeit(ByVal Sekunden As Integer)
        ms = Sekunden * 1000
        Weiter = False
        Dim T As Thread = New Thread(AddressOf Warten)
        T.Start()
        Do
            Application.DoEvents()
        Loop Until Weiter = True
        Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Warten wurde eingeleitet"
    End Sub
    Private Sub Warten()
        Thread.Sleep(ms)
        Weiter = True
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
        Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Imports waren erolgreich und das Programm wird gestartet"
        '##################### Laden von Einstellungen ####################
        ' Autosave aktiviert?
        If My.Settings.autosave = True Then
            FlatLabel2.Visible = True
            toggleAutosave.Checked = True
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Autosave wurde aktiviert (load)"
        Else
            FlatLabel2.Visible = False
            toggleAutosave.Checked = False
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Autosave wurde deaktiviert (load)"
        End If
        'onepersoncontrol aktiviert?
        If My.Settings.personcontrol = True Then
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Personenkontrolle wurde aktiviert (load)"
            toggleOnepseroncontrol.Checked = True
        Else
            toggleOnepseroncontrol.Checked = False
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Personenkontrolle wurde deaktiviert (load)"
        End If

    End Sub
    Public Sub Startsub()
        Wartezeit(0)
        '########################################
        '###############Server###################
        'Zum Server verbinden
        serverconnect()

        'Anmeldung verstecken und den Ladescreen anzeigen


        'Log.dat definieren

        'one Person Control
        ' Löschen von Get.dll


        ' Download von get.dll
        getdownload()
        'Warten????
        '      Wartezeit(5)
        'get.dll lesen
        readGet()
        'Überprüfen ob personcontrol an ist
        If My.Settings.personcontrol = True Then
            If getinfo.Text = "1" Then
                alert.Text = "Es wird gerade von einer anderen Instanz auf den Server zugegriffen!"
                alert.kind = FlatAlertBox._Kind.Info
                alert.Show()
                Me.Show()
            Else
                '## Bestimmen von User daten und Server
                'Den wert von get.dll (personcontrol auf 1 setzen)
                getToOneAndUpload()

                'löschen der alten Log Datei
                deleteLog()
                'Download der neuen Log Datei
                downloadLog()

                '############## Download von Data.zip ######################################
                ' Löschen des Data Ordners
                deleteDataFolder()
                'Data.zip löschen und herunterladen
                deleteDataZip()
                downloadDataZip()

                'Data.zip entpacken
                extractDataZip()
                readLog()
            End If
        End If
        Me.MinimumSize = New Size(900, 400)
        fontSizeNumeric.Value = My.Settings.fontSize
        txtInhalt.Font = New Font("Segoe UI", My.Settings.fontSize, FontStyle.Regular)
        Me.Show()
        Pass.Hide()
    End Sub

    Public Sub ListBox_Read(ByVal ListBox As ListBox, ByVal sFile As String)
        '###########################Listbox einträge lesen###########################
        Dim oStream As IO.StreamReader
        Dim sLine As String

        ListBox.Items.Clear()
        Dim oFile As New IO.FileInfo(sFile)

        If oFile.Exists() = True Then
            oStream = New IO.StreamReader(sFile)

            Do
                sLine = oStream.ReadLine()
                If IsNothing(sLine) Then Exit Do
                ListBox.Items.Add(sLine)

            Loop

            oStream.Close()
        End If
        Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Logliste wurde erfolgreich gelesen"
    End Sub

    Private Sub FlatButton1_Click(sender As Object, e As EventArgs) Handles btnAdd.Click
        Try
            'Keine checkbox ist angewählt
            If Not wichtigcheck.Checked Then
                If Not Defektcheck.Checked Then
                    listLogs.Items.Add(txtEntry.Text & " " & System.DateTime.Now.Date)
                    Dim Name1 As String
                    Name1 = txtEntry.Text
                    My.Computer.FileSystem.WriteAllText(Application.StartupPath & "\Data\" & Name1 & " " & Date.Now.Date & ".dat", txtInhalt.Text, False)
                End If
            End If

            ' Nur checkbox 1 ist angewählt
            If wichtigcheck.Checked Then
                If Not Defektcheck.Checked Then
                    listLogs.Items.Add("WICHTIG " & txtEntry.Text & " " & System.DateTime.Now.Date)
                    Dim Name2 As String
                    Name2 = txtEntry.Text
                    My.Computer.FileSystem.WriteAllText(Application.StartupPath & "\Data\" & "WICHTIG " & Name2 & " " & Date.Now.Date & ".dat", txtInhalt.Text, False)
                End If
            End If

            'Nur checkbox 2 ist angewählt
            If Defektcheck.Checked Then
                If Not wichtigcheck.Checked Then
                    listLogs.Items.Add("defekt " & txtEntry.Text & " " & System.DateTime.Now.Date)
                    Dim Name3 As String
                    Name3 = txtEntry.Text
                    My.Computer.FileSystem.WriteAllText(Application.StartupPath & "\Data\" & "defekt " & Name3 & " " & Date.Now.Date & ".dat", txtInhalt.Text, False)
                End If
            End If

            ' Beide checkboxen sind angewählt
            If Defektcheck.Checked Then
                If wichtigcheck.Checked Then
                    listLogs.Items.Add("WD " & txtEntry.Text & " " & System.DateTime.Now.Date)
                    Dim Name4 As String
                    Name4 = txtEntry.Text
                    My.Computer.FileSystem.WriteAllText(Application.StartupPath & "\Data\" & "WD " & Name4 & " " & Date.Now.Date & ".dat", txtInhalt.Text, False)
                End If
            End If
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Neuer Log wurde erfolgreich erstellt"
        Catch
            alert.Text = "Datei konnte nicht geschrieben werden!"
            alert.kind = FlatAlertBox._Kind.Error
            alert.Show()
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Datei konnte nicht geschrieben werden"
        End Try

        '####Listbox speichern####
        ListBox_Save(listLogs, sFile)
        Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Logliste wurde erfolgreich gespeichert"
        'Textbox speichern
    End Sub
    Public Sub ListBox_Save(ByVal ListBox As ListBox,
  ByVal sFile As String)
        '#########################Listbox speichern#####################################
        Dim oStream As IO.StreamWriter
        Dim i As Short

        oStream = New IO.StreamWriter(sFile)

        For i = 0 To CShort(ListBox.Items.Count - 1)
            oStream.WriteLine(ListBox.Items(i))
        Next
        oStream.Close()
        Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Logliste wurde erfolgreich gespeichert"
    End Sub

    Private Sub Logliste_SelectedIndexChanged(sender As Object, e As EventArgs) Handles listLogs.SelectedIndexChanged
        My.Settings.Autosavetimer = 5
        Autosave.Stop()
        Try
            txtInhalt.Text = ""
            Dim names As String
            names = Application.StartupPath & "\Data\" & listLogs.SelectedItem.ToString & ".dat"
            Text = My.Computer.FileSystem.ReadAllText(names)
            txtInhalt.Text = Text
            Me.Text = "Logbuch Grimmergy" & "  |  " & listLogs.SelectedItem.ToString
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Log wurde erfolgreich gelesen"
        Catch
            alert.kind = FlatAlertBox._Kind.Error
            alert.Text = "Log konnte nicht gelesen werden"
            alert.Show()
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Log konnte nicht gelesen werden"
        End Try
        Autosave.Start()
    End Sub

    Private Sub Autosave_Tick(sender As Object, e As EventArgs)
        logspeichern()
    End Sub

    Private Sub FlatButton2_Click(sender As Object, e As EventArgs) Handles btnSync.Click, btnSync.Click
        If My.Settings.lokal = False Then
            '######################Datei verpacken##############################################
            Try
                Dim zipFileName As String = "Data.zip"
                Dim fileNames As String() = Directory.GetFiles(Application.StartupPath & "\Data\")

                Using zip As Ionic.Zip.ZipFile = New Ionic.Zip.ZipFile
                    For Each file In fileNames
                        zip.AddFile(file, "Data")
                    Next
                    zip.Save(zipFileName)
                End Using
                Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Data Ordner wurde verpackt"
            Catch
                alert.kind = FlatAlertBox._Kind.Error
                alert.Text = "Beim Verpacken des ""Data"" Ordners ist ein Fehler aufgetreten"
                alert.Show()
                Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Der Data Ordner konnte nicht verpackt werden"
            End Try

            '######################Server Sync############################################

            Try

                'Upload der Data.zip 

                success = ftp.PutFile(Application.StartupPath & "\Data.zip", "Data.zip")
                If (success <> True) Then
                    System.Console.WriteLine(ftp.LastErrorText)
                    Exit Sub
                End If

                alert.Text = "Server Sync erfolgreich"
                alert.kind = FlatAlertBox._Kind.Success
                alert.Show()
                Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Der ServerSync wurde erfolgreich abgeschlossen"
            Catch
                alert.kind = FlatAlertBox._Kind.Error
                alert.Text = "Beim Upload vom Zip Paket ist ein Fehler aufgetreten!"
                alert.Show()
                Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Der Upload vpm Zip-Paket ist fehlgeschlagen"
            End Try
            ' Upload von Log.dat
            Try

                success = ftp.PutFile(Application.StartupPath & "\log.dat", "log.dat")
                If (success <> True) Then
                    System.Console.WriteLine(ftp.LastErrorText)
                    Exit Sub
                End If
                Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Upload von log.dat war erfolgreich"
            Catch ex As Exception
                alert.Text = "Beim Upload von log.dat ist ein Fehler aufgetreten!" & ex.Message
                alert.kind = FlatAlertBox._Kind.Error
                alert.Show()
                Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Upload von log.dat ist fehlgeschlagen"
            End Try
        End If
    End Sub

    Private Sub FlatButton3_Click(sender As Object, e As EventArgs) Handles btnDel.Click
        'Makierten Eintraf löschen
        Try
            listLogs.Items.Remove(listLogs.SelectedItem)
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Item wurde erfolgreich aus der Liste entfernt"
            alert.Hide()
        Catch
            alert.Text = "Item oder Datei konnte nicht entfernt werden!"
            alert.kind = FlatAlertBox._Kind.Error
            alert.Show()
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Item in der Liste konnte nicht entfernt werden"
        End Try
        'Listbox speichern
        Try
            Dim sFile As String
            sFile = Application.StartupPath & "\Log.dat"
            ListBox_Save(listLogs, sFile)
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Logliste wurde gespeichert"
        Catch
            alert.Text = "ListBox konnte nicht gespeichert werden"
            alert.kind = FlatAlertBox._Kind.Error
            alert.Show()
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Einträge der Logliste konnten nicht gespeichert werden"
        End Try
    End Sub

    Private Sub FlatButton4_Click(sender As Object, e As EventArgs) Handles btnSave.Click
        ' Manuelles abspeichern von Loginhalt
        logspeichern()
        Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Datei wurde manuell gespeichert"
    End Sub

    Private Sub FlatToggle1_CheckedChanged(sender As Object) Handles toggleAutosave.CheckedChanged
        ' Autosave einschalten oder ausschalten
        If My.Settings.autosave = True Then
            My.Settings.autosave = False
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Autosave wurde deaktiviert"
            Autosave.Stop()
        ElseIf My.Settings.autosave = False Then
            My.Settings.autosave = True
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Autosave wurde aktiviert"
            Autosave.Start()
        End If
        My.Settings.Save()
    End Sub

    Private Sub logspeichern()
        Try
            Dim Name As String
            Name = Application.StartupPath & "\Data\" & listLogs.SelectedItem.ToString & ".dat"
            My.Computer.FileSystem.WriteAllText(Name, txtInhalt.Text, False)
        Catch
            alert.kind = FlatAlertBox._Kind.Error
            alert.Text = "Konnte Datei nicht speichern (FlatButton4_click)"
        End Try
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing

        e.Cancel = True
        If getinfo.Text = "0" Then
            Try

                getting = "0"

                uploadGet()

            Catch
                alert.kind = FlatAlertBox._Kind.Error
                alert.Text = "Konnte Datei nicht speichern (get.dll)"
            End Try
        Else
            Application.Exit()
        End If
    End Sub


    Private Sub FlatClose1_Click(sender As Object, e As EventArgs) Handles FlatClose1.Click
        If getinfo.Text = "0" Then
            Try
                getting = "0"

                uploadGet()

            Catch
                alert.kind = FlatAlertBox._Kind.Error
                alert.Text = "Konnte Datei nicht speichern (get.dll)"
            End Try
        Else
            Application.Exit()
        End If
    End Sub

    Private Sub FlatButton6_Click(sender As Object, e As EventArgs) Handles btnResetPersoncontrol.Click
        Try
            getting = "0"

            uploadGet()

        Catch
            alert.kind = FlatAlertBox._Kind.Error
            alert.Text = "Konnte Datei nicht speichern (get.dll)"
        End Try
    End Sub

    Private Sub FlatButton7_Click(sender As Object, e As EventArgs) Handles btnAutorepair.Click
        Try
            Dim zipFileName As String = "Data.zip"
            Dim fileNames As String() = Directory.GetFiles(Application.StartupPath & "\Error\")

            Using zip As Ionic.Zip.ZipFile = New Ionic.Zip.ZipFile
                For Each file In fileNames
                    zip.AddFile(file, "Data")
                Next
                zip.Save(zipFileName)
            End Using
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Fehlerbehebung: Data Ordner wurde verpackt"
        Catch
            alert.kind = FlatAlertBox._Kind.Error
            alert.Text = "Beim Verpacken des ""Data"" Ordners ist ein Fehler aufgetreten"
            alert.Show()
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Der Data Ordner konnte nicht verpackt werden"
        End Try
        Try
            My.Computer.FileSystem.CreateDirectory(Application.StartupPath & "\Data\")
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Fehlerbehebung: Data Ordner wurde Erstellt (Bitte das Programm versuchen neu zu starten)"
        Catch


        End Try
        alert.Text = "Automatische Fehlerbehebung: Bitte das Programm neu starten!"
        alert.kind = FlatAlertBox._Kind.Info
        alert.Show()
    End Sub

    Private Sub FlatButton8_Click(sender As Object, e As EventArgs) Handles btnSaveftpdata.Click
        '###################Einstellungen in Datei schreiben######################
        'FTP-Server speichern
        Try
            My.Settings.Server = servertxt.Text
        Catch
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Der FTP-Server konnte nicht gespeichert werden"
        End Try

        Try
            My.Settings.User = usertxt.Text
        Catch
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Der FTP-Benutzer konnte nicht geändert werden"
        End Try
        ' Konstrolle ob das Passwort gespeichert werden soll

        alert.Text = "Die Einstellungen wurden gespeichert. Um diese zu aktivieren, bitte das Programm neu starten!"
        alert.kind = FlatAlertBox._Kind.Info
        alert.Show()
    End Sub

    Private Sub FlatButton1_Click_1(sender As Object, e As EventArgs) Handles btnmanuellDownload.Click
        downloadDataZip()
        extractDataZip()
    End Sub

    '#################Definieren einzelner SUB's um doppelten Code zu vermeiden######################

    Private Sub getdownload()
        Try
            gettinglocal = ftp.GetRemoteFileTextData("get.dll")
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "get.dll wurde erfolgreich herrtuntergeladen"
        Catch
            alert.Text = "Beim lesen der Personenkontrolle ist ein Fehler aufgetreten"
            alert.kind = FlatAlertBox._Kind.Error
            alert.Show()
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "get.dll konnte nicht gelesen werden"
        End Try
    End Sub

    Private Sub getToOneAndUpload()

        Try
            getting = "1"

            uploadGet()
        Catch
            alert.kind = FlatAlertBox._Kind.Error
            alert.Text = "get.dll konnte nicht hochgeladen werden!"
            alert.Show()
        End Try

    End Sub

    Private Sub readGet()
        Try
            getinfo.Text = gettinglocal
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "get.dll wurde erfolgreich gelesen"
        Catch
            alert.kind = FlatAlertBox._Kind.Error
            alert.Text = "get.dll konnte nicht gelesen werden"
            alert.Show()
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "get.dll konnte nicht gelesen werden"
        End Try
    End Sub

    Private Sub serverconnect()
        success = ftp.UnlockComponent("sdfgsdkfngmklsdnfg456u48956u7345hjgjdfsgnds")
        If (success <> True) Then
            System.Console.WriteLine(ftp.LastErrorText)

            Exit Sub
        End If
        My.Settings.Reload()
        ftp.Hostname = My.Settings.Server
        ftp.Username = My.Settings.User
        ftp.Password = Pass.txtpass.Text

        success = ftp.Connect()
        If (success <> True) Then
            System.Console.WriteLine(ftp.LastErrorText)
            ftp.Disconnect()
            Serverconfig.Hide()
            Pass.Show()
            Me.Hide()
            Pass.FlatAlertBox1.Visible = True
            Exit Sub
        End If
        Pass.txtpass.Text = ""
    End Sub



    Private Sub deleteLog()
        If My.Computer.FileSystem.FileExists(Application.StartupPath & "\log.dat") Then
            Try
                My.Computer.FileSystem.DeleteFile(Application.StartupPath & "\log.dat")
                Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "log.dat wurde erfolgreich gelöscht"
            Catch
                alert.Text = "Beim löschen der alten Log Datei ist ein Fehler aufgetreten"
                alert.kind = FlatAlertBox._Kind.Error
                alert.Show()
                Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Alte log.dat konnte nicht gelöscht werden"
            End Try
        Else
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " &
                "log.dat konnte nicht gelöscht werden. Die Datei existiert nicht!"
            alert.kind = FlatAlertBox._Kind.Error
            alert.Text = "log.dat konnte nicht gefunden werden"
            alert.Show()
        End If
    End Sub

    Private Sub downloadLog()
        Try
            success = ftp.GetFile("log.dat", Application.StartupPath & "\log.dat")
            If (success <> True) Then
                System.Console.WriteLine(ftp.LastErrorText)
                Exit Sub
            End If
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "log.dat wurde erfolgreich herruntergeladen"
        Catch ex As Exception
            alert.Text = "Bei dem Download von der neuen Log datei ist ein Fehler aufgetreten"
            alert.kind = FlatAlertBox._Kind.Error
            alert.Show()
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "log.dat konnte nicht herruntergeladen werden"
        End Try
    End Sub

    Private Sub deleteDataFolder()
        If My.Computer.FileSystem.DirectoryExists(Application.StartupPath & "\Data") Then
            Try
                Directory.Delete(Application.StartupPath & "\Data\", True)
                'Warten????
                ' Wartezeit(10)
            Catch
                Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Ordner konnte nicht gelöscht werden"
            End Try
        Else
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " &
                "Der Data-Ordner konnte nicht gelöscht werden. Die Datei existiert nicht!"
            alert.kind = FlatAlertBox._Kind.Error
            alert.Text = "Data-Ordner konnte nicht gefunden werden"
            alert.Show()
        End If
    End Sub

    Private Sub deleteDataZip()
        If My.Computer.FileSystem.FileExists(Application.StartupPath & "\Data.zip") Then
            Try
                My.Computer.FileSystem.DeleteFile(Application.StartupPath & "\Data.zip")
                'Warten????
                '   Wartezeit(10)
            Catch
                Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Data.zip konnte nicht gelöscht werden"
            End Try
        Else
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " &
                "Data.zip konnte nicht gelöscht werden. Die Datei existiert nicht!"
            alert.kind = FlatAlertBox._Kind.Error
            alert.Text = "Data.zip konnte nicht gefunden werden"
            alert.Show()
        End If
    End Sub

    Private Sub downloadDataZip()
        Try
            success = ftp.GetFile("Data.zip", Application.StartupPath & "\Data.zip")
            If (success <> True) Then
                System.Console.WriteLine(ftp.LastErrorText)
                Exit Sub
            End If
        Catch
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Data.zip konnte nicht herruntergeladen werden"
        End Try
    End Sub

    Private Sub extractDataZip()
        If My.Computer.FileSystem.FileExists(Application.StartupPath & "\Data.zip") Then
            Try
                Using zip As Ionic.Zip.ZipFile =
               ZipFile.Read(Application.StartupPath & "\Data.zip")
                    For Each zip_entry As Ionic.Zip.ZipEntry In zip
                        zip_entry.Extract(Application.StartupPath)
                    Next zip_entry
                End Using

                alert.Text = "Download erfolgreich"
                alert.kind = FlatAlertBox._Kind.Success
                alert.Show()
                Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Data Ordner wurde erfolgreich herruntergeladen"
            Catch ex As Exception
                alert.Text = "Archniv konnte nicht entpackt werden.\n" & " " & ex.Message
                alert.kind = FlatAlertBox._Kind.Error
                alert.Show()
                Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Data Ordner konnte nicht entpackt werden"
            End Try
        Else
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " &
                "Data.zip konnte nicht entpackt werden. Die Datei existiert nicht!"
            alert.kind = FlatAlertBox._Kind.Error
            alert.Text = "Data.zip konnte nicht gefunden werden"
            alert.Show()
        End If
    End Sub

    Private Sub readLog()
        If My.Computer.FileSystem.FileExists(Application.StartupPath & "\log.dat") Then

            Try
                sFile = Application.StartupPath & "\log.dat"
                ListBox_Read(listLogs, sFile)
                Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "log.dat wurde erfolgreich eingelesen"
            Catch
                alert.Text = "Die Datei konnte nicht gelesen werden"
                alert.kind = FlatAlertBox._Kind.Error
                alert.Show()
                Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "log.dat konnte nicht gelesen werden"
            End Try
        Else
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " &
                "log.dat konnte nicht gelesen werden. Die Datei existiert nicht!"
            alert.kind = FlatAlertBox._Kind.Error
            alert.Text = "log.dat konnte nicht gefunden werden"
            alert.Show()
        End If
    End Sub

    Private Sub uploadGet()


        Try
            success = ftp.PutFileFromTextData("get.dll", getting, "Windows-1252")
            If (success <> True) Then
                System.Console.WriteLine(ftp.LastErrorText)
                Exit Sub
            End If
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "upload von get.dll erfolgreich"
        Catch
            alert.kind = FlatAlertBox._Kind.Error
            alert.Text = "get.dll konnte nicht hochgeladen werden!"
            alert.Show()
        End Try

    End Sub

    Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (
   ByVal hwnd As IntPtr, ByVal wMsg As Int32, ByVal wParam As Int32, ByVal _
   lParam As IntPtr) As Int32
    Private Declare Function ReleaseCapture Lib "user32.dll" () As Int32

    Private Const HTBOTTOM As Int32 = 15
    Private Const HTBOTTOMLEFT As Int32 = 16
    Private Const HTBOTTOMRIGHT As Int32 = 17
    Private Const WM_NCLBUTTONDOWN As Int32 = &HA1

    Private Sub Button1_MouseDown(ByVal sender As System.Object, ByVal e As _
      System.Windows.Forms.MouseEventArgs) Handles Panel3.MouseDown
        ReleaseCapture()
        SendMessage(Me.Handle, WM_NCLBUTTONDOWN, HTBOTTOMRIGHT, IntPtr.Zero)
    End Sub

    Private Sub LinkerButton_MouseDown(ByVal sender As System.Object, ByVal e _
      As System.Windows.Forms.MouseEventArgs) Handles Panel5.MouseDown
        ReleaseCapture()
        SendMessage(Me.Handle, WM_NCLBUTTONDOWN, HTBOTTOMLEFT, IntPtr.Zero)
    End Sub

    Private Sub MittlererButton_MouseDown(ByVal sender As System.Object, ByVal _
      e As System.Windows.Forms.MouseEventArgs) Handles _
      Panel2.MouseDown
        ReleaseCapture()
        SendMessage(Me.Handle, WM_NCLBUTTONDOWN, HTBOTTOM, IntPtr.Zero)
    End Sub

    Private Sub txtInhalt_TextChanged(sender As Object, e As EventArgs)

    End Sub

    Private Sub Autosave_Tick_1(sender As Object, e As EventArgs) Handles Autosave.Tick
        If My.Settings.Autosavetimer = 0 Then
            logspeichern()
            Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Datei wurde automatisch gespeichert"
            My.Settings.Autosavetimer = 5
            FlatLabel2.Text = "Speichern erfolgreich"
            My.Settings.Save()
        Else
            My.Settings.Autosavetimer = My.Settings.Autosavetimer - 1
            FlatLabel2.Text = "Autosave: " & My.Settings.Autosavetimer.ToString
            My.Settings.Save()
        End If
    End Sub

    Private Sub txtInhalt_TextChanged_1(sender As Object, e As EventArgs) Handles txtInhalt.TextChanged
        My.Settings.Autosavetimer = 5
        My.Settings.Save()
        FlatLabel2.Text = "Autosave: " : My.Settings.Autosavetimer.ToString()
    End Sub

    Private Sub FlatNumeric1_Click(sender As Object, e As EventArgs) Handles fontSizeNumeric.Click
        My.Settings.fontSize = fontSizeNumeric.Value
        My.Settings.Save()
        txtInhalt.Font = New Font("Segoe UI", My.Settings.fontSize, FontStyle.Regular)
        Console.Text = Console.Text & vbNewLine & System.DateTime.Now & " " & "Schriftgröße wurde zu " & fontSizeNumeric.Value.ToString & " geändert"
    End Sub

    Private Sub consolesend_Click(sender As Object, e As EventArgs) Handles Consolesend.Click
        Dim addcommand As String
        addcommand = consoleadd.Text.ToLower
        Select Case addcommand
            Case "help"
                Console.Text = Console.Text & vbNewLine & consoleadd.Text
                Console.Text = Console.Text & vbNewLine &
                    "changefontsize <Value>" & vbNewLine &
                    "to change the font size" & vbNewLine &
                    "help" & vbNewLine &
                    "to view the help page" & vbNewLine &
                    "personcontrol on/off" & vbNewLine &
                    "to toggle personcontrol on or off" & vbNewLine &
                    "autosave on/off " & vbNewLine &
                    "to toggle autosave on or off"


            Case "changefontsize"
                If consoleadd.Text.Contains("changefontsize") Then
                    Console.Text = Console.Text & vbNewLine & consoleadd.Text & vbNewLine
                    Console.Text = Console.Text & consoleadd.Text(16)
                End If


        End Select
        If consoleadd.Text.Contains("changefontsize ") Then
            Console.Text = Console.Text & vbNewLine & consoleadd.Text & vbNewLine
            Try
                Dim one As String = "0"
                Dim two As String = "0"
                Dim three As String = "0"
                Try
                    one = consoleadd.Text(15)
                Catch
                End Try
                Try
                    two = consoleadd.Text(16)
                Catch
                End Try
                Try
                    three = consoleadd.Text(17)
                Catch
                End Try
                If Not three = "0" Then
                    Console.Text = Console.Text & "The font size have ben changed to " & one & two & three
                ElseIf Not two = "0" Then
                    Console.Text = Console.Text & "The font size have ben changed to " & one & two
                ElseIf Not one = "0" Then
                    Console.Text = Console.Text & "The font size have ben changed to " & one
                End If
                catch
            End Try
        End If
    End Sub
End Class
