﻿Option Strict On
Imports System.IO
Imports Chilkat
Imports Ionic.Zip
Public Class Serverconfig
    '####FTP-Werte
    Dim ftp As New Chilkat.Ftp2()
    Dim success As Boolean
    '####Pfad
    Dim localFilename As String
    Dim remoteFilename As String
    Private Sub FlatButton1_Click(sender As Object, e As EventArgs) Handles FlatButton1.Click
        '#######FTP-Komponente aktivieren################################################
        success = ftp.UnlockComponent("adsfadsfkljakl34j986790au3490au80938405uj0asdjf")
        If (success <> True) Then
            MsgBox(ftp.LastErrorText)
            Exit Sub
        End If
        '#######Anmelden am Server#######################################################
        ftp.Hostname = FlatTextBox1.Text
        ftp.Username = FlatTextBox2.Text
        ftp.Password = FlatTextBox3.Text
        success = ftp.Connect()
        If (success <> True) Then
            MsgBox(ftp.LastErrorText)
            Exit Sub
        End If

        '#####Zip-Paket erstellen#########################################################
        Try
            Dim zipFileName As String = "Data.zip"
            Dim fileNames As String() = Directory.GetFiles(Application.StartupPath & "\Error\")

            Using zip As Ionic.Zip.ZipFile = New Ionic.Zip.ZipFile
                For Each file In fileNames
                    zip.AddFile(file, "Data")
                Next
                zip.Save(zipFileName)
            End Using
        Catch
        End Try
        Try
            My.Computer.FileSystem.CreateDirectory(Application.StartupPath & "\Data\")
        Catch
        End Try

        '#######Upload###############################################
        Try
            remoteFilename = "Data.zip"
            localFilename = Application.StartupPath & "\Data.zip"
            success = ftp.PutFile(localFilename, remoteFilename)
            If (success <> True) Then
                MsgBox(ftp.LastErrorText)
                Exit Sub
            End If
        Catch
        End Try
        '########Personcontrol=1#########################################
        Try
            Dim geting As String
            geting = Application.StartupPath & "\get.dll"
            My.Computer.FileSystem.WriteAllText(geting, "1", False)
            remoteFilename = "get.dll"
            localFilename = Application.StartupPath & "\get.dll"
            success = ftp.PutFile(localFilename, remoteFilename)
            If (success <> True) Then
                MsgBox(ftp.LastErrorText)
                Exit Sub
            End If
        Catch

        End Try
        '########Erstellen&Upload der Liste##########################################
        'Löschen von Log.dat
        Try
            If My.Computer.FileSystem.FileExists(Application.StartupPath & "\log.dat") Then
                My.Computer.FileSystem.DeleteFile(Application.StartupPath & "\log.dat")
            Else
            End If
            'erstellen von log.dat
            Dim path As String = Application.StartupPath & "\log.dat"
            Dim fs As FileStream = File.Create(path)
            Dim info As Byte() = New System.Text.UTF8Encoding(True).GetBytes("")
            fs.Write(info, 0, info.Length)
            fs.Close()
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
        'Upload
        Try
            remoteFilename = "log.dat"
            localFilename = Application.StartupPath & "\log.dat"
            success = ftp.PutFile(localFilename, remoteFilename)
            If (success <> True) Then
                MsgBox(ftp.LastErrorText)
                Exit Sub
            End If
        Catch ex As Exception
        End Try
        '########Abspeichern(Nutername&Server)##############################
        Try
            'Server
            My.Settings.Server = FlatTextBox1.Text
            'Benutzername
            My.Settings.User = FlatTextBox2.Text
            'Speichern
            My.Settings.Save()
        Catch
        End Try
        '#########Meldung anzeigen###########################################
        Pass.FlatAlertBox1.kind = FlatAlertBox._Kind.Success
        Pass.FlatAlertBox1.Text = "Die Einstellungen wurden gespeichert!"
        Pass.FlatAlertBox1.Show()
        Pass.Show()
        Me.Hide()
    End Sub
End Class